      SUBROUTINE FTA6R(ARRAY,NDIM,MESH,IREG)
      INTEGER NDIM,MESH,IREG,NTOT,IDIM,NPREV,N,NREM,IP1,IP2,IP3,I2REV,
     *I2,I1,I2IP1,I3REV,I3,IBIT,IFP1,IFP2,I3IP1,K1,K2
      REAL ARRAY,TEMPR,TEMPI
      DOUBLE PRECISION WR,WI,WPR,WPI,WTEMP,THETA,SYS003
      DIMENSION ARRAY(1),MESH(NDIM)
      DATA SYS003/6.283185307179586D0/
      NTOT=1
      DO 10 IDIM=1,NDIM
      NTOT=NTOT*MESH(IDIM)
   10 CONTINUE
      NPREV=1
      DO 140 IDIM=1,NDIM
      N=MESH(IDIM)
      NREM=NTOT/(N*NPREV)
      IP1=2*NPREV
      IP2=IP1*N
      IP3=IP2*NREM
      I2REV=1
      DO 80 I2=1,IP2,IP1
      IF(I2.GE.I2REV) GO TO 40
      I2IP1=I2+IP1-2
      DO 30 I1=I2,I2IP1,2
      DO 20 I3=I1,IP3,IP2
      I3REV=I2REV+I3-I2
      TEMPR=ARRAY(I3)
      TEMPI=ARRAY(I3+1)
      ARRAY(I3)=ARRAY(I3REV)
      ARRAY(I3+1)=ARRAY(I3REV+1)
      ARRAY(I3REV)=TEMPR
      ARRAY(I3REV+1)=TEMPI
   20 CONTINUE
   30 CONTINUE
   40 IBIT=IP2/2
   50 IF((IBIT.GE.IP1).AND.(I2REV.GT.IBIT)) GO TO 60
      GO TO 70
   60 I2REV=I2REV-IBIT
      IBIT=IBIT/2
      GO TO 50
   70 I2REV=I2REV+IBIT
   80 CONTINUE
      IFP1=IP1
   90 IF(IFP1.GE.IP2) GO TO 130
      IFP2=2*IFP1
      THETA=IREG*SYS003/(IFP2/IP1)
      WPR=-2.0D0*DSIN(0.5D0*THETA)**2
      WPI=DSIN(THETA)
      WR=1.0D0
      WI=0.0D0
      DO 120 I3=1,IFP1,IP1
      I3IP1=I3+IP1-2
      DO 110 I1=I3,I3IP1,2
      DO 100 I2=I1,IP3,IFP2
      K1=I2
      K2=K1+IFP1
      TEMPR=SNGL(WR)*ARRAY(K2)-SNGL(WI)*ARRAY(K2+1)
      TEMPI=SNGL(WR)*ARRAY(K2+1)+SNGL(WI)*ARRAY(K2)
      ARRAY(K2)=ARRAY(K1)-TEMPR
      ARRAY(K2+1)=ARRAY(K1+1)-TEMPI
      ARRAY(K1)=ARRAY(K1)+TEMPR
      ARRAY(K1+1)=ARRAY(K1+1)+TEMPI
  100 CONTINUE
  110 CONTINUE
      WTEMP=WR
      WR=WR*WPR-WI*WPI+WR
      WI=WI*WPR+WTEMP*WPI+WI
  120 CONTINUE
      IFP1=IFP2
      GO TO 90
  130 NPREV=N*NPREV
  140 CONTINUE
      IF(IREG.EQ.1) GO TO 160
      N=2*NTOT
      TEMP=1.0/FLOAT(NTOT)
      DO 150 I1=1,N
      ARRAY(I1)=TEMP*ARRAY(I1)
  150 CONTINUE
  160 RETURN
      END
